/*
 * Copyright (C) 2016  Thadeu Lima de Souza Cascardo <cascardo@cascardo.eti.br>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, visit the http://fsf.org website.
 */

#include "init.h"
#include <stdio.h>

#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>

#define PREFIX "/sys/class/android_usb/android0/"

int do_write(char *fname, char *text)
{
	int fd;
	fd = open(fname, O_WRONLY);
	write(fd, text, strlen(text));
	close(fd);
	return 0;
}

int do_read(char *fname, char *buffer, size_t len)
{
	int fd;
	int r;
	fd = open(fname, O_RDONLY);
	r = read(fd, buffer, len);
	close(fd);
	return r;
}

int main(int argc, char **argv)
{
	int r;
	int fd = -1;
	char dev[33];
	int maj, min;
	r = devmount_setup();
	if (r < 0) {
		fprintf(stderr, "failed to mount devtmpfs, proceeding anyway\n");
	}
	r = sysfsmount_setup();
	if (r < 0) {
		fprintf(stderr, "failed to mount sysfs, proceeding anyway\n");
	}
	do_write(PREFIX "/enable", "0");
	do_write(PREFIX "/idVendor", "04E8");
	do_write(PREFIX "/idProduct", "6860");
	do_write(PREFIX "/f_acm/acm_transports", "tty");
	do_write(PREFIX "/functions", "acm");
	do_write(PREFIX "/enable", "1");
	while (do_read("/sys/class/tty/ttyGS0/dev", dev, sizeof(dev)) < 0) {
		sleep(1);
	}
	sscanf(dev, "%d:%d", &maj, &min);
	mknod("/dev/ttyGS0", 0666 | S_IFCHR, makedev(maj, min));
	fd = open("/dev/ttyGS0", O_RDWR);
	while (1) {
		write(fd, "Hello World!\n", 13);
		sleep(1);
	}
	return 0;
}
